/*-
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 69):
 * <syrinx@FreeBSD.org> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return.   -Shteryana Shopova
 * ----------------------------------------------------------------------------
 */

#include <gtk/gtk.h>

GtkWidget *window;
GdkPixmap *cg_pixmap;
GtkWidget *drawing_area;

/* XXX:  FIXME!!! */
void cg_line_drawing_refresh(gint x1, gint y1, gint x2, gint y2);

typedef void (*cg_draw_line_cb) (GdkDrawable *drawable, GdkGC *gc, gint x1_,
    gint y1_, gint x2_, gint y2_);

/*
 * A global structure to hold the info for the current line that
 * is being drawed.
 */
struct _cg_line {
	gboolean	X1_set;	/* coordinates of first point are established */
	gint		X1;	/* firts point X axis value */
	gint		Y1;	/* firts point Y axis value */
	gint		X2;	/* second point X axis value */
	gint		Y2;	/* second point Y axis value */
	gulong		button_id;	/*  button press/release handler id */
	gulong		motion_id;	/*  mouse motion handler id */
	cg_draw_line_cb	draw_cb;	/* the line draw callback */
};

struct _cg_line cg_line;

gint cg_line_button_press_event(GtkWidget *widget, GdkEventButton *event);

#define	CG_CIRCLE_TRANSLATE(delta, z)		((z) - (delta))
#define	CG_CIRCLE_REV_TRANSLATE(delta, z)	((z) + (delta))

void cg_circle_draw_four_symmetric_pts(GdkDrawable *drawable, GdkGC *gc,
    gint trans_x, gint trans_y, gint x_, gint y_);

/* A line segment defined by its two endpoints. */
struct cg_segment_line {
	gint	x1_;
	gint	y1_;
	gint	x2_;
	gint	y2_;
};

/* END: FIXME!!! */

/*
 * Methods for drawing lines.
 */
void cg_line_inline(GtkWidget *w, gpointer data);
void cg_line_simple(GtkWidget *w, gpointer data);
void cg_line_bresenhaim(GtkWidget *w, gpointer data);
void cg_line_portion(GtkWidget *w, gpointer data);

/*
 * Methods for drawing circles.
 */
void cg_circle_inline(GtkWidget *w, gpointer data);
void cg_circle_simple(GtkWidget *w, gpointer data);
void cg_circle_simple2(GtkWidget *w, gpointer data);
void cg_circle_bresenhaim(GtkWidget *w, gpointer data);
void cg_circle_michener(GtkWidget *w, gpointer data);
void cg_circle_delta2(GtkWidget *w, gpointer data);

/*
 * Methods for ellipses.
 */
void cg_ellipse_set_input(gpointer callback_data, guint callback_action,
    GtkWidget *menu_item);
void cg_ellipse_inline(GtkWidget *w, gpointer data);
void cg_ellipse_bresenhaim(GtkWidget *w, gpointer data);
void cg_ellipse_conic(GtkWidget *w, gpointer data);

/*
 * Methods for polygons.
 */
void cg_polygon_scan_line(GtkWidget *w, gpointer data);
void cg_polygon_cyrus_beck(GtkWidget *w, gpointer data);
void cg_polygon_sh(GtkWidget *w, gpointer data);
void cg_polygon_wa(GtkWidget *w, gpointer data);

/*
 * Methods for clipping a line segment from a rectangle.
 */
void cg_rectangle_cs(GtkWidget *w, gpointer data);
void cg_rectangle_lb(GtkWidget *w, gpointer data);
void cg_rectangle_nln(GtkWidget *w, gpointer data);

/*
 * Saying some BS when "Other" menu item is clicked.
 */
void cg_other_spline(GtkWidget *w, gpointer data);
void cg_other_holiday(GtkWidget *w, gpointer data);
void cg_other_overhauser(GtkWidget *w, gpointer data);
void cg_other_b_spline(GtkWidget *w, gpointer data);
void cg_other_besier(GtkWidget *w, gpointer data);
void cg_other_ferguson(GtkWidget *w, gpointer data);

