/*-
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 69):
 * <syrinx@FreeBSD.org> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return.   -Shteryana Shopova
 * ----------------------------------------------------------------------------
 */

#include "cg.h"

enum cg_other_texts {
	CG_OTHER_SPLINE = 0,
	CG_OTHER_HOLIDAY = 1,
	CG_OTHER_OVERHAUSER = 2,
	CG_OTHER_B_SPLINE = 3,
	CG_OTHER_BESIER = 4,
	CG_OTHER_FERGUSON = 5,
	CG_OTHER_NUMBER,
};

/* Obligatory basic callbacks for the "Other" menu items. */
static void cg_other_print_text(GtkWidget *w, enum cg_other_texts method);

void
cg_other_spline(GtkWidget *w, gpointer data)
{
	g_message ("Hello, cg_other_spline!\n");
	cg_other_print_text(w, CG_OTHER_SPLINE);
}

void
cg_other_holiday(GtkWidget *w, gpointer data)
{
	g_message ("Hello, cg_other_holiday!\n");
	cg_other_print_text(w, CG_OTHER_HOLIDAY);
}

void
cg_other_overhauser(GtkWidget *w, gpointer data)
{
	g_message ("Hello, cg_other_overhauser!\n");
	cg_other_print_text(w, CG_OTHER_OVERHAUSER);
}

void
cg_other_b_spline(GtkWidget *w, gpointer data)
{
	g_message ("Hello, cg_other_b_spline!\n");
	cg_other_print_text(w, CG_OTHER_B_SPLINE);
}

void
cg_other_besier(GtkWidget *w, gpointer data)
{
	g_message ("Hello, cg_other_besier!\n");
	cg_other_print_text(w, CG_OTHER_BESIER);
}

void
cg_other_ferguson(GtkWidget *w, gpointer data)
{
	g_message ("Hello, cg_other_ferguson!\n");
	cg_other_print_text(w, CG_OTHER_FERGUSON);
}

const gchar text_spline[] = "\
		Spline!\n\
";

const gchar text_holiday[] = "\
	Say something about Holiday's theorem!\n\
	Say something about Holiday's theorem!\n\
	Say something about Holiday's theorem!\n";


const gchar text_overhauser[] = "\
	Say something about Overhauser curves!\n\
	Say something about Overhauser curves!\n\
	Say something about Overhauser curves!\n";

const gchar text_b_spline[] = "\
	Say something about B-splines!\n\
	Say something about B-splines!\n\
	Say something about B-splines!\n";

const gchar text_besier[] = "\
	Say something about Besier curves!\n\
	Say something about Besier curves!\n\
	Say something about Besier curves!\n";

const gchar text_ferguson[] = "\
	Say something about Ferguson curves!\n\
	Say something about Ferguson curves!\n\
	Say something about Ferguson curves!\n";

const struct text_entries {
	enum cg_other_texts	id;
	const gchar		*text;
} cg_other_texts[CG_OTHER_NUMBER] = {
	{ CG_OTHER_SPLINE,  text_spline },
	{ CG_OTHER_HOLIDAY, text_holiday },
	{ CG_OTHER_OVERHAUSER, text_overhauser },
	{ CG_OTHER_B_SPLINE, text_b_spline },
	{ CG_OTHER_BESIER, text_besier },
	{ CG_OTHER_FERGUSON, text_ferguson },
};

static void
cg_other_print_text(GtkWidget *w, enum cg_other_texts method)
{
	const gchar *text;
	static GtkWidget *dialog;
	GtkWidget *text_w, *sc_w, *button;

	if (method >= CG_OTHER_NUMBER)
		return;
	else
		text = cg_other_texts[method].text;

	/*
	 * Create a new dialog window for the scrolled window to be
	 * packed into.
	 */
	dialog = gtk_dialog_new ();
	g_signal_connect(G_OBJECT(dialog), "destroy",
	    G_CALLBACK(gtk_main_quit), NULL);

	gtk_container_set_border_width(GTK_CONTAINER(dialog), 0);
	gtk_widget_set_size_request(dialog, 800, 600);

	sc_w = gtk_scrolled_window_new(NULL, NULL);

	gtk_container_set_border_width(GTK_CONTAINER(sc_w), 10);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(sc_w),
	    GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);


	/* The dialog window is created with a vbox packed into it. */
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), sc_w,
	    TRUE, TRUE, 0);

	gtk_widget_show(sc_w);

	/* Add a "OK" button to the bottom of the dialog. */
	button = gtk_button_new_with_label("OK");

	g_signal_connect_swapped (G_OBJECT(button), "clicked",
	    G_CALLBACK(gtk_widget_hide), G_OBJECT(dialog));

	text_w = gtk_cell_view_new_with_text(text);

	//gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox),
	//    text_w, TRUE, TRUE, 0);
	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(sc_w), text_w);
	gtk_widget_show(text_w);

	/* This makes the "OK" button default. */
	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
	    button, TRUE, TRUE, 0);

	/*
	 * This grabs this button to be the default button. Simply hitting
	 * the "Enter" key will cause this button to activate.
	 */
	gtk_widget_grab_default(button);
	gtk_widget_show(button);

	gtk_widget_show (dialog);
}
